//+------------------------------------------------------------------+
//|                          HiLow channel - Jurik double smooth.mq4 |
//|                                                           mladen |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "copyleft mladen"
#property link      "mladenfx@gmail.com"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Red
#property indicator_color2 DeepSkyBlue
#property indicator_width1 2
#property indicator_width2 2

//
//
//
//
//

extern string TimeFrame       = "current time frame";
extern int    SmoothPeriod    = 10;
extern int    SmoothPhase     =  0;
extern bool   Interpolate     = true;
extern bool   alertsOn        = false;
extern bool   alertsOnCurrent = true;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = false;
extern bool   alertsEmail     = false;

//
//
//
//
//

double ssld[];
double sslu[];
double Hlv[];

//
//
//
//
//

int    timeFrame;
bool   calculating = false;
bool   returnBars  = false;
string IndicatorFileName;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(3);
   SetIndexBuffer(0,ssld);
   SetIndexBuffer(1,sslu);
   SetIndexBuffer(2,Hlv);
   SetIndexLabel(0,"Down");
   SetIndexLabel(1,"Up");
   
   //
   //
   //
   //
   //
   
      if (TimeFrame == "calculate")    { calculating = true; return(0); }
      if (TimeFrame == "getBarsCount") { returnBars  = true; return(0); }   

       timeFrame = MathMax(stringToTimeFrame(TimeFrame),Period());

   //
   //
   //
   //
   //
         
   IndicatorFileName = WindowExpertName();
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   double calcSmoothPeriod = MathSqrt(SmoothPeriod);
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { ssld[0] = limit; return(0); }

   //
   //
   //
   //
   //

   if (timeFrame > Period()) limit = MathMax(limit,MathMin(Bars,iCustom(NULL,timeFrame,IndicatorFileName,"getBarsCount",0,0)*timeFrame/Period()));
   if (!calculating && timeFrame != Period())
   {
      for(i=limit;i>=0;i--)
      {
         int      bar  = iBarShift(NULL,timeFrame,Time[i]);
         datetime	time = iTime    (NULL,timeFrame,bar);
         
            ssld[i] = iCustom(NULL,timeFrame,IndicatorFileName,"calculate",SmoothPeriod,SmoothPhase,0,bar); 
            sslu[i] = iCustom(NULL,timeFrame,IndicatorFileName,"calculate",SmoothPeriod,SmoothPhase,1,bar); 
            Hlv[i]  = Hlv[i+1];
                  if (sslu[i]>ssld[i]) Hlv[i] =  1;
                  if (sslu[i]<ssld[i]) Hlv[i] = -1;
                  if (timeFrame <= Period() || bar==iBarShift(NULL,timeFrame,Time[i-1])) continue;
                  if (!Interpolate) continue;
        
            //
            //
            //
            //
            //

            for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
            double factor = 1.0 / n;
               for(int k = 1; k < n; k++)
               {
      		      ssld[i+k] = k*factor*ssld[i+n] + (1.0-k*factor)*ssld[i];
		    	      sslu[i+k] = k*factor*sslu[i+n] + (1.0-k*factor)*sslu[i];
               }			      
      }   
   }
   
   //
   //
   //
   //
   //
   
   else
   
   //
   //
   //
   //
   //
   
   {
      for(i=limit;i>=0;i--)
      {
         double hiPrice = iDSmooth(High[i+1],calcSmoothPeriod,SmoothPhase,i+1, 0);
         double loPrice = iDSmooth(Low[i+1] ,calcSmoothPeriod,SmoothPhase,i+1,20);
         double clPrice = iDSmooth(Close[i] ,calcSmoothPeriod,SmoothPhase,i  ,40);

         //
         //
         //
         //
         //

         Hlv[i] = Hlv[i+1];
            if(clPrice>hiPrice) Hlv[i] =  1;
            if(clPrice<loPrice) Hlv[i] = -1;
      
            if(Hlv[i] == -1)
               {
                  ssld[i] = hiPrice;
                  sslu[i] = loPrice;
               }               
            else
               {
                  ssld[i] = loPrice;
                  sslu[i] = hiPrice;
               } 
      }
   }

   //
   //
   //
   //
   //
   
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
         if (Hlv[whichBar] != Hlv[whichBar+1])
         if (Hlv[whichBar] == 1)
               doAlert("up");
         else  doAlert("down");       
   }
      
   //
   //
   //
   //
   //
         
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+  
//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," High-Low channel direction changed to ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"High-Low channel "),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   for(int l = StringLen(tfs)-1; l >= 0; l--)
   {
      int char = StringGetChar(tfs,l);
          if((char > 96 && char < 123) || (char > 223 && char < 256))
               tfs = StringSetChar(tfs, l, char - 32);
          else 
              if(char > -33 && char < 0)
                  tfs = StringSetChar(tfs, l, char + 224);
   }

   //
   //
   //
   //
   //
   
   int tf=Period();
         if (tfs=="M1" || tfs=="1")     tf=PERIOD_M1;
         if (tfs=="M5" || tfs=="5")     tf=PERIOD_M5;
         if (tfs=="M15"|| tfs=="15")    tf=PERIOD_M15;
         if (tfs=="M30"|| tfs=="30")    tf=PERIOD_M30;
         if (tfs=="H1" || tfs=="60")    tf=PERIOD_H1;
         if (tfs=="H4" || tfs=="240")   tf=PERIOD_H4;
         if (tfs=="D1" || tfs=="1440")  tf=PERIOD_D1;
         if (tfs=="W1" || tfs=="10080") tf=PERIOD_W1;
         if (tfs=="MN" || tfs=="43200") tf=PERIOD_MN1;
   return(tf);
}

//+------------------------------------------------------------------
//|                                                                 
//+------------------------------------------------------------------
//
//
//
//
//

double wrk[][60];

#define bsmax  5
#define bsmin  6
#define volty  7
#define vsum   8
#define avolty 9

//
//
//
//
//

double iDSmooth(double price, double length, double phase, int i, int s=0)
{
   return (iSmooth(iSmooth(price,length,phase,i,s),length,phase,i,s+10));
}

//
//
//
//
//

double iSmooth(double price, double length, double phase, int i, int s=0)
{
   if (length <=1) return(price);
   if (ArrayRange(wrk,0) != Bars) ArrayResize(wrk,Bars);
   
   int r = Bars-i-1; 
      if (r==0) { for(int k=0; k<7; k++) wrk[r][k+s]=price; for(; k<10; k++) wrk[r][k+s]=0; return(price); }

   //
   //
   //
   //
   //
   
      double len1   = MathMax(MathLog(MathSqrt(0.5*(length-1)))/MathLog(2.0)+2.0,0);
      double pow1   = MathMax(len1-2.0,0.5);
      double del1   = price - wrk[r-1][bsmax+s];
      double del2   = price - wrk[r-1][bsmin+s];
      double div    = 1.0/(10.0+10.0*(MathMin(MathMax(length-10,0),100))/100);
      int    forBar = MathMin(r,10);
	
         wrk[r][volty+s] = 0;
               if(MathAbs(del1) > MathAbs(del2)) wrk[r][volty+s] = MathAbs(del1); 
               if(MathAbs(del1) < MathAbs(del2)) wrk[r][volty+s] = MathAbs(del2); 
         wrk[r][vsum+s] =	wrk[r-1][vsum+s] + (wrk[r][volty+s]-wrk[r-forBar][volty+s])*div;
         
         //
         //
         //
         //
         //
   
         wrk[r][avolty+s] = wrk[r-1][avolty+s]+(2.0/(MathMax(4.0*length,30)+1.0))*(wrk[r][vsum+s]-wrk[r-1][avolty+s]);
            if (wrk[r][avolty+s] > 0)
               double dVolty = wrk[r][volty+s]/wrk[r][avolty+s]; else dVolty = 0;   
	               if (dVolty > MathPow(len1,1.0/pow1)) dVolty = MathPow(len1,1.0/pow1);
                  if (dVolty < 1)                      dVolty = 1.0;

      //
      //
      //
      //
      //
	        
   	double pow2 = MathPow(dVolty, pow1);
      double len2 = MathSqrt(0.5*(length-1))*len1;
      double Kv   = MathPow(len2/(len2+1), MathSqrt(pow2));

         if (del1 > 0) wrk[r][bsmax+s] = price; else wrk[r][bsmax+s] = price - Kv*del1;
         if (del2 < 0) wrk[r][bsmin+s] = price; else wrk[r][bsmin+s] = price - Kv*del2;
	
   //
   //
   //
   //
   //
      
      double R     = MathMax(MathMin(phase,100),-100)/100.0 + 1.5;
      double beta  = 0.45*(length-1)/(0.45*(length-1)+2);
      double alpha = MathPow(beta,pow2);

         wrk[r][0+s] = price + alpha*(wrk[r-1][0+s]-price);
         wrk[r][1+s] = (price - wrk[r][0+s])*(1-beta) + beta*wrk[r-1][1+s];
         wrk[r][2+s] = (wrk[r][0+s] + R*wrk[r][1+s]);
         wrk[r][3+s] = (wrk[r][2+s] - wrk[r-1][4+s])*MathPow((1-alpha),2) + MathPow(alpha,2)*wrk[r-1][3+s];
         wrk[r][4+s] = (wrk[r-1][4+s] + wrk[r][3+s]); 

   //
   //
   //
   //
   //

   return(wrk[r][4+s]);
}